---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "rapportageservice.fullname" . }}
  labels:
    {{- include "rapportageservice.labels" . | nindent 4 }}
spec:
  {{- if not .Values.autoscaling.enabled }}
  replicas: {{ .Values.replicaCount }}
  {{- end }}
  selector:
    matchLabels:
      {{- include "rapportageservice.selectorLabels" . | nindent 6 }}
  template:
    metadata:
      labels:
        {{- include "rapportageservice.selectorLabels" . | nindent 8 }}
    spec:
      enableServiceLinks: false
      automountServiceAccountToken: false
      securityContext:
        {{- toYaml .Values.podSecurityContext | nindent 8 }}
      containers:
        - name: {{ .Chart.Name }}
          securityContext:
            {{- toYaml .Values.securityContext | nindent 12 }}
          image: "{{ .Values.image.repository }}:{{ coalesce .Values.image.tag .Values.global.image.tag | default .Chart.AppVersion }}"
          imagePullPolicy: "{{ coalesce .Values.image.pullPolicy .Values.global.image.pullPolicy }}"
          ports:
            - name: http
              containerPort: 8000
              protocol: TCP
          startupProbe:
            httpGet:
              path: /health
              port: http
            periodSeconds: 10
            failureThreshold: 60
          livenessProbe:
            httpGet:
              path: /health
              port: http
            periodSeconds: 10
          readinessProbe:
            httpGet:
              path: /health
              port: http
            periodSeconds: 10
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
          env:
            {{- with .Values.global }}{{- if .rabbitmq.enabled }}
            - name: RABBITMQ_HOST
              valueFrom:
                secretKeyRef:
                  name: {{ printf "%s-rabbitmq" $.Release.Name }}
                  key: host
            - name: RABBITMQ_PORT
              valueFrom:
                secretKeyRef:
                  name: {{ printf "%s-rabbitmq" $.Release.Name }}
                  key: port
            - name: RABBITMQ_USER
              valueFrom:
                secretKeyRef:
                  name: {{ printf "%s-rabbitmq" $.Release.Name }}
                  key: username
            - name: RABBITMQ_PASS
              valueFrom:
                secretKeyRef:
                  name: {{ printf "%s-rabbitmq" $.Release.Name }}
                  key: password
            {{- end }}
            {{- if .huishoudboekjeservice.enabled }}
            - name: HHB_SERVICE_URL
              value: {{ printf "http://%s-%s" $.Release.Name "huishoudboekjeservice" | quote }}
            {{- end }}{{- if .banktransactieservice.enabled }}
            - name: TRANSACTIE_SERVICE_URL
              value: {{ printf "http://%s-%s" $.Release.Name "banktransactieservice"  | quote }}
            {{- end }}{{- end }}
            - name: LOG_LEVEL
              value: {{ coalesce .Values.log_level .Values.global.log_level | upper | quote }}
            {{- if .Values.global.metrics.enabled }}
            - name: STATSD_HOST
              value: {{ .Values.global.metrics.host }}
            {{- end }}
            - name: GUNICORN_WORKER_TIMEOUT
              value: "0"
            {{- if .Values.extraEnvVars }}{{- toYaml .Values.extraEnvVars | nindent 12 }}{{- end }}
        {{- if and .Values.global.metrics.enabled .Values.global.metrics.prometheusExporter.enabled }}
        - name: statsd-prometheus-exporter
          image: "{{ .Values.global.metrics.prometheusExporter.image.repository }}:{{ .Values.global.metrics.prometheusExporter.image.tag }}"
          imagePullPolicy: "{{ coalesce .Values.image.pullPolicy .Values.global.image.pullPolicy }}"
          securityContext:
            {{- toYaml .Values.securityContext | nindent 12 }}
          ports:
            - name: metrics
              containerPort: 9102
              protocol: TCP
        {{- end }}
